/*
snglelim Version 0.1.0 - Single Elimination Pairings
Copyright (C) 2002  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>

#define MAX 10
#define DOWN 0
#define UP 1

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s rounds\n", pgm);
   fprintf(stderr,"Where rounds is 2 - %d\n", MAX);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,j,k,totrounds;
   int round,thisround;
   int players;
   int dir;
   int *lst,*nxtlst;
   if (argc != 2) putstx(*argv);
   totrounds = atoi(*(argv+1));
   if (totrounds < 2 || totrounds > MAX) putstx(*argv);
   players = 1 << totrounds;
   lst = (int *) malloc(players * sizeof(int) + 16);
   nxtlst = (int *) malloc(players * sizeof(int) + 16);
   i = 0;
   while (i < players)
      {
      lst[i] = nxtlst[i] = 0;
      i++;
      } /* clear both lists */
   lst[0] = 1;
   lst[1] = 2;
   printf("Round %d\n", totrounds);
   printf("%4d vs %4d\n\n", 1, 2);
   i = 1;
   while (i < totrounds)
      {
      thisround = 1 << (i + 1);
      dir = DOWN;
      j = 0;
      k = 0;
      while (j < players)
         {
         if (!lst[j]) break;
         if (dir == DOWN)
            {
            nxtlst[k] = lst[j];
            nxtlst[k+1] = thisround - (lst[j] - 1);
            } /* if down */
         else
            {
            nxtlst[k] = thisround - (lst[j] - 1);
            nxtlst[k+1] = lst[j];
            } /* if down */
         dir ^= 1;
         j++;
         k += 2;
         } /* for each player in round */
      j = 0;
      while (j < players)
         {
         if (!nxtlst[j]) break;
         lst[j] = nxtlst[j];
         j++;
         } /* copy back to lst */
      printf("Round %d\n", totrounds - i);
      j = 0;
      while (j < players)
         {
         if (!lst[j]) break;
         printf("%4d vs %4d\n",
            lst[j], lst[j+1]);
         j += 2;
         } /* for each pair */
      putchar('\n');
      i++;
      } /* round by round */
   return(0);
   } /* main */
